{
Client Access Objects 1.5

Data aware and ExecSQL demo using TcaoQuery

(c) 1998, 1999 Steven P. Goldsmith
All Rights Reserved

Make sure you change the systemName of the TcaoDatabaseConnection component to
your system name.  Set systemName, userID and password of the TcaoSecurity
component.

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 1, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

sgoldsmith@home.com
http://members.home.net/sgoldsmith/
}

unit DataAwareExecSQLMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Grids, DBGrids, StdCtrls, ComCtrls, Menus, Db, caoQuery,
  caoDatabaseSQL, caoDatabaseParmMarkerFormat, caoDatabaseSQLCA,
  caoDatabaseDataFormat, caoDatabaseConnection, caoErrorMessage,
  caoSecurity, DBCtrls;

const

  appInsertCount = 50;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Table1: TMenuItem;
    Create1: TMenuItem;
    Insert1: TMenuItem;
    Open1: TMenuItem;
    Close1: TMenuItem;
    Drop1: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    RichEdit1: TRichEdit;
    DBGrid1: TDBGrid;
    Splitter1: TSplitter;
    caoSecurity1: TcaoSecurity;
    caoErrorMessage1: TcaoErrorMessage;
    caoDatabaseConnection1: TcaoDatabaseConnection;
    caoDatabaseDataFormat1: TcaoDatabaseDataFormat;
    caoDatabaseSQLCA1: TcaoDatabaseSQLCA;
    caoDatabaseParmMarkerFormat1: TcaoDatabaseParmMarkerFormat;
    caoDatabaseSQL1: TcaoDatabaseSQL;
    caoQuery1: TcaoQuery;
    DataSource1: TDataSource;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure caoSecurity1Logon(Sender: TObject);
    procedure caoDatabaseConnection1Active(Sender: TObject);
    procedure Create1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Insert1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure Drop1Click(Sender: TObject);
  private
    { Private declarations }
    procedure Log(S : string);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Log(S : string);
var
  CurDateFmt : string;
  CurDateTime: TDateTime;
begin
  try
    try
      CurDateTime := Now;
      CurDateFmt := ShortDateFormat;
      ShortDateFormat := 'mm/dd/yy';
      with RichEdit1.SelAttributes do
      begin
        Color := clBlack;
      end;
      // Add line to rich edit with date and time prefix
      RichEdit1.Lines.Add (Format('%s %s',[DateTimeToStr(CurDateTime),S]))
    except
      RichEdit1.Lines.Clear
    end
  finally
    ShortDateFormat := CurDateFmt
  end
end;

{
Logon and connect to database.
}

procedure TForm1.FormShow(Sender: TObject);
begin
  Log(Format('Logging on to %s',[caoDatabaseConnection1.systemName]));
  caoSecurity1.LogonUser;
  caoErrorMessage1.Setup;
  caoDatabaseConnection1.Active := True
end;

{
Close query and database connection.
}

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  caoQuery1.Active := False;
  caoDatabaseConnection1.Active := False
end;

procedure TForm1.caoSecurity1Logon(Sender: TObject);
begin
  Log('Logon complete');
end;

procedure TForm1.caoDatabaseConnection1Active(Sender: TObject);
begin
  Log('Database connection active')
end;

{
Create table.
}

procedure TForm1.Create1Click(Sender: TObject);
begin
  Log('Create table');
  with caoQuery1 do
  begin
    Active := False;
    statementText.Clear;
    statementText.Add('CREATE TABLE QTEMP/SQLTEST (');
    statementText.Add('NUMFLD NUMERIC(5,0),');
    statementText.Add('CHARFLD CHAR(20))');
    ExecSQL
  end
end;

{
Open table.
}

procedure TForm1.Open1Click(Sender: TObject);
begin
  Log('Open table');
  with caoQuery1 do
  begin
    Active := False;
    statementText.Clear;
    statementText.Add('SELECT * FROM QTEMP/SQLTEST');
    Active := True
  end
end;

{
Insert records.
}

procedure TForm1.Insert1Click(Sender: TObject);
var
  I: Integer;
begin
  Log('Insert');
  with caoQuery1 do
  begin
    Active := False;
    for I := 1 to appInsertCount do
    begin
      statementText.Clear;
      statementText.Add(Format(
      'INSERT INTO QTEMP/SQLTEST VALUES (%d,''char value %0:d'')',
      [I]));
      ExecSQL
    end
  end;
  Log(Format('%d records',[appInsertCount]))
end;

{
Close table.
}

procedure TForm1.Close1Click(Sender: TObject);
begin
  caoQuery1.Active := False
end;

{
Drop table.
}

procedure TForm1.Drop1Click(Sender: TObject);
begin
  Log('Drop table');
  with caoQuery1 do
  begin
    Active := False;
    statementText.Clear;
    statementText.Add('DROP TABLE QTEMP/SQLTEST');
    ExecSQL
  end
end;

end.
